<?php
//===============================================================

// Settings:

// Absolute path to message files (NO trailing slash!)
$messages_path = '/path/for/messages/txt';

// Print stats when NOT using php-cli (1 = enabled)
$print_stats = '0';

//===============================================================

// Resets
$d = array();
$count = '0';
$time_start = '';
$time_end = '';
$time_total = '';
$file = '';
$time_check = '';
$dir = '';
$file_print = '';

// Start execution timer
$time_start = microtime(true);

// Define timers for: days
$d['1'] = strtotime('-24 hours');
$d['3'] = strtotime('-3 days');
$d['7'] = strtotime('-7 days');
$d['30'] = strtotime('-30 days');
$d['60'] = strtotime('-60 days');

// Define timers for: hours
$d['1h'] = strtotime('-60 minutes');
$d['6h'] = strtotime('-6 hours');
$d['12h'] = strtotime('-12 hours');

// Define timers for: minutes
$d['15m'] = strtotime('-15 minutes');
$d['30m'] = strtotime('-30 minutes');
$d['45m'] = strtotime('-45 minutes');

// Print some info
if ( defined('STDIN') ) {

	echo '______________________________________'.PHP_EOL;
	echo PHP_EOL;
	echo 'Securely deleting expired messages...'.PHP_EOL;
	echo PHP_EOL;
}
elseif ( $print_stats == '1' ) {
	echo '<b>Securely deleting expired messages...</b><br />';
	echo '<br />';
}

//___________________________________________________________

// Process all timers/directories
foreach ( $d as $dir => $time_check ) {
	
	// List all files (messages) for specified directory
	foreach (glob($messages_path.'/'.$dir.'/*') as $file){
		
		// Check if message is expired
		if ( filemtime($file) <= $time_check ){
			
			// Increment counter
			$count++;
			
			// Securely delete file (7-pass shred)
			exec("sudo shred -f --remove=unlink -n 7 $file");
			
			// Print deleted file info when running via command line
			if ( defined('STDIN') ) {
				$file_print = str_replace($messages_path, '', $file);
				echo $count.': Deleted: '.$file_print.PHP_EOL;
			}
			elseif ( $print_stats == '1' ) {
				$file_print = str_replace($messages_path, '', $file);
				echo '<b>'.$count.':</b> Deleted: '.$file_print.'<br />';
			}
		} // end of: check if message is expired
		
	} // end of: foreach: list messages for specified directory

} // end of: foreach: process all timers/directories

//___________________________________________________________

// Stop execution timer
$time_end = microtime(true);
$time_total = $time_end - $time_start + 0;
$time_total = round($time_total, 4);

// Print total stats (when using php-cli)
if ( defined('STDIN') ) {
	echo PHP_EOL;
	echo 'Total messages deleted: '.$count.PHP_EOL;
	echo 'Total execution time: '.$time_total.' sec'.PHP_EOL;
	echo '______________________________________'.PHP_EOL;
	echo PHP_EOL;
}
// Print total stats (when NOT using php-cli)
elseif ( $print_stats == '1' ) {
	echo '<br />';
	echo '<b>Total messages deleted:</b> '.$count.'<br />';
	echo '<b>Total execution time:</b> '.$time_total.' sec<br />';
	echo '<br />';
}
elseif ( $print_stats == '0' ){
	echo 'All done!';
}

?>
