<?php

//===============================================================

// Settings:

// Absolute path to the statistics files (NO trailing slash!)
$stats_path = '/path/for/messages/txt/stats';

// Absolute path to the directory which contains notes and note counters (NO trailing slash!)
$messages_path = '/path/for/messages/txt';

// Print stats when NOT using php-cli (1 = enabled)
$print_stats = '0';

//===============================================================

// Resets
$d = array();
$count = '0';
$count_deleted = '0';
$message_count_1d = '0';
$message_count_7d = '0';
$message_count_30d = '0';
$page_hits = '0';
$time_start = '';
$time_end = '';
$time_total = '';
$file = '';
$time_check = '';
$dir = '';
$file_print = '';

// Start execution timer
$time_start = microtime(true);

// Print some info
if ( defined('STDIN') ) {
	echo '______________________________________'.PHP_EOL;
	echo PHP_EOL;
	echo 'Deleting expired statistics files...'.PHP_EOL;
	echo PHP_EOL;
}
elseif ( $print_stats == '1' ) {
	echo '<b>Deleting expired statistics files...</b><br />';
	echo '<br />';
}

// Define timers/directories
$d['1'] = strtotime('-24 hours');
$d['7'] = strtotime('-7 days');
$d['30'] = strtotime('-30 days');
$d['hits'] = strtotime('-24 hours');

//___________________________________________________________

// Process all timers/directories
foreach ( $d as $dir => $time_check ) {
	
	// List all files for specified directory
	foreach (glob($stats_path.'/'.$dir.'/*') as $file){
		
		// Check if file is expired
		if ( filemtime($file) <= $time_check ){
			
			// Increment counter
			$count_deleted++;
			
			// Delete stats file
			//exec("rm -f $file");
			unlink($file);
			
			// Print deleted file info when running via command line
			if ( defined('STDIN') ) {
				$file_print = str_replace($stats_path, '', $file);
				echo $count_deleted.': Deleted: '.$file_print.PHP_EOL;
			}
			elseif ( $print_stats == '1' ) {
				$file_print = str_replace($stats_path, '', $file);
				echo '<b>'.$count_deleted.':</b> Deleted: '.$file_print.'<br />';
			}
		} // end of: check if file is expired
		
	} // end of: foreach: list all files for specified directory

} // end of: foreach: process all timers/directories

//___________________________________________________________

// Print total count of deleted expired stats
if ( defined('STDIN') ) {
	echo PHP_EOL;
	echo 'Total statistics files deleted: '.$count_deleted.PHP_EOL;

}
elseif ( $print_stats == '1' ) {
	echo '<br />';
	echo '<b>Total statistics files deleted:</b> '.$count_deleted.'<br />';
}

//___________________________________________________________

// Print some info
if ( defined('STDIN') ) {
	echo '______________________________________'.PHP_EOL;
	echo PHP_EOL;
	echo 'Calculating statistics...'.PHP_EOL;
	echo PHP_EOL;
}
elseif ( $print_stats == '1' ) {
	echo '______________________________________<br /><br />';
	echo '<b>Calculating statistics...</b><br />';
	echo '<br />';
}

// Count messages waiting to be read
$count = $count + count(glob("$messages_path/15m/" . "*.iv"));
$count = $count + count(glob("$messages_path/30m/" . "*.iv"));
$count = $count + count(glob("$messages_path/45m/" . "*.iv"));
$count = $count + count(glob("$messages_path/1h/" . "*.iv"));
$count = $count + count(glob("$messages_path/6h/" . "*.iv"));
$count = $count + count(glob("$messages_path/12h/" . "*.iv"));
$count = $count + count(glob("$messages_path/1/" . "*.iv"));
$count = $count + count(glob("$messages_path/3/" . "*.iv"));
$count = $count + count(glob("$messages_path/7/" . "*.iv"));
$count = $count + count(glob("$messages_path/30/" . "*.iv"));
$count = $count + count(glob("$messages_path/60/" . "*.iv"));
$count = round($count);

// Count created messages within 1, 7, 30 days (skip dots)
$message_count_1d = iterator_count(new FilesystemIterator("$stats_path/1/", FilesystemIterator::SKIP_DOTS));
$message_count_7d = iterator_count(new FilesystemIterator("$stats_path/7/", FilesystemIterator::SKIP_DOTS));
$message_count_30d = iterator_count(new FilesystemIterator("$stats_path/30/", FilesystemIterator::SKIP_DOTS));

// Count page hits today (skip dots)
$page_hits = iterator_count(new FilesystemIterator("$stats_path/hits/", FilesystemIterator::SKIP_DOTS));

//_________________________________________

// Write 1 day stats into file
$fp = fopen("$stats_path/1.txt", "w");
fwrite($fp , $message_count_1d);
fclose($fp);

// Print stats for: messages written within 24 hours
if ( defined('STDIN') ) {
	echo 'New messages in 24 hours: '.$message_count_1d.PHP_EOL;
}
elseif ( $print_stats == '1' ) {
	echo '<b>New messages in 24 hours: </b> '.$message_count_1d.'<br />';
}

//_________________________________________

// Write 7 day stats into file
$fp = fopen("$stats_path/7.txt", "w");
fwrite($fp , $message_count_7d);
fclose($fp);

// Print stats for: messages written within 7 days
if ( defined('STDIN') ) {
	echo 'New messages in 7 days: '.$message_count_7d.PHP_EOL;
}
elseif ( $print_stats == '1' ) {
	echo '<b>New messages in 7 days:</b> '.$message_count_7d.'<br />';
}

//_________________________________________

// Write 30 day stats into file
$fp = fopen("$stats_path/30.txt", "w");
fwrite($fp , $message_count_30d);
fclose($fp);

// Print stats for: messages written within 30 days
if ( defined('STDIN') ) {
	echo 'New messages in 30 days: '.$message_count_30d.PHP_EOL;
}
elseif ( $print_stats == '1' ) {
	echo '<b>New messages in 30 days:</b> '.$message_count_30d.'<br />';
}

//_________________________________________

// Write messages waiting to be read count into file
$fp = fopen("$stats_path/waiting.txt", "w");
fwrite($fp , $count);
fclose($fp);

// Print stats for: messages waiting to be read:
if ( defined('STDIN') ) {
	echo 'Unread / waiting messages: '.$count.PHP_EOL;
}
elseif ( $print_stats == '1' ) {
	echo '<b>Unread / waiting messages:</b> '.$count.'<br />';
}

//_________________________________________

// Write page hits today into file
$fp = fopen("$stats_path/hits.txt", "w");
fwrite($fp , $page_hits);
fclose($fp);

// Stop execution timer
$time_end = microtime(true);
$time_total = $time_end - $time_start + 0;
$time_total = round($time_total, 4);

// Print stats for: page hits today
if ( defined('STDIN') ) {
	echo 'Page hits today: '.$page_hits.PHP_EOL;
	echo PHP_EOL;
	echo 'Total execution time: '.$time_total.' sec'.PHP_EOL;
	echo '______________________________________'.PHP_EOL;
	echo PHP_EOL;
}
elseif ( $print_stats == '1' ) {
	echo '<b>Page hits today:</b> '.$page_hits.'<br />';
	echo '<br />';
	echo '<b>Total execution time:</b> '.$time_total.' sec<br />';
	echo '<br />';
}
// All done
elseif ( $print_stats == '0' ) {
	echo 'All done!';
}
//_________________________________________

?>
